// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: device_server.proto
#ifndef GRPC_device_5fserver_2eproto__INCLUDED
#define GRPC_device_5fserver_2eproto__INCLUDED

#include "device_server.pb.h"

#include <grpcpp/impl/codegen/async_stream.h>
#include <grpcpp/impl/codegen/async_unary_call.h>
#include <grpcpp/impl/codegen/method_handler_impl.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace grpc {
class CompletionQueue;
class Channel;
class ServerCompletionQueue;
class ServerContext;
}  // namespace grpc

namespace mascot {

class MascotDeviceServer final {
 public:
  static constexpr char const* service_full_name() {
    return "mascot.MascotDeviceServer";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Device definition
    virtual ::grpc::Status GetAttributeList(::grpc::ClientContext* context, const ::mascot::GetAttributeListMessage& request, ::mascot::AttributeListReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::AttributeListReply>> AsyncGetAttributeList(::grpc::ClientContext* context, const ::mascot::GetAttributeListMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::AttributeListReply>>(AsyncGetAttributeListRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::AttributeListReply>> PrepareAsyncGetAttributeList(::grpc::ClientContext* context, const ::mascot::GetAttributeListMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::AttributeListReply>>(PrepareAsyncGetAttributeListRaw(context, request, cq));
    }
    virtual ::grpc::Status GetCommandList(::grpc::ClientContext* context, const ::mascot::GetCommandListMessage& request, ::mascot::CommandListReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::CommandListReply>> AsyncGetCommandList(::grpc::ClientContext* context, const ::mascot::GetCommandListMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::CommandListReply>>(AsyncGetCommandListRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::CommandListReply>> PrepareAsyncGetCommandList(::grpc::ClientContext* context, const ::mascot::GetCommandListMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::CommandListReply>>(PrepareAsyncGetCommandListRaw(context, request, cq));
    }
    // Attributes
    virtual ::grpc::Status ReadAttribute(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::mascot::ReadAttributeReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::ReadAttributeReply>> AsyncReadAttribute(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::ReadAttributeReply>>(AsyncReadAttributeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::ReadAttributeReply>> PrepareAsyncReadAttribute(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::ReadAttributeReply>>(PrepareAsyncReadAttributeRaw(context, request, cq));
    }
    virtual ::grpc::Status WriteAttribute(::grpc::ClientContext* context, const ::mascot::WriteAttributeMessage& request, ::mascot::WriteReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>> AsyncWriteAttribute(::grpc::ClientContext* context, const ::mascot::WriteAttributeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>>(AsyncWriteAttributeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>> PrepareAsyncWriteAttribute(::grpc::ClientContext* context, const ::mascot::WriteAttributeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>>(PrepareAsyncWriteAttributeRaw(context, request, cq));
    }
    // Configuration
    virtual ::grpc::Status ReadAttributeConfig(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::mascot::AttributeConfigReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::AttributeConfigReply>> AsyncReadAttributeConfig(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::AttributeConfigReply>>(AsyncReadAttributeConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::AttributeConfigReply>> PrepareAsyncReadAttributeConfig(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::AttributeConfigReply>>(PrepareAsyncReadAttributeConfigRaw(context, request, cq));
    }
    // Properties
    virtual ::grpc::Status ReadDeviceProperties(::grpc::ClientContext* context, const ::mascot::ReadDevicePropertiesMessage& request, ::mascot::DeviceProperties* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DeviceProperties>> AsyncReadDeviceProperties(::grpc::ClientContext* context, const ::mascot::ReadDevicePropertiesMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DeviceProperties>>(AsyncReadDevicePropertiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DeviceProperties>> PrepareAsyncReadDeviceProperties(::grpc::ClientContext* context, const ::mascot::ReadDevicePropertiesMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DeviceProperties>>(PrepareAsyncReadDevicePropertiesRaw(context, request, cq));
    }
    virtual ::grpc::Status WriteDeviceProperties(::grpc::ClientContext* context, const ::mascot::DeviceProperties& request, ::mascot::WriteReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>> AsyncWriteDeviceProperties(::grpc::ClientContext* context, const ::mascot::DeviceProperties& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>>(AsyncWriteDevicePropertiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>> PrepareAsyncWriteDeviceProperties(::grpc::ClientContext* context, const ::mascot::DeviceProperties& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>>(PrepareAsyncWriteDevicePropertiesRaw(context, request, cq));
    }
    // Attribute Meta
    virtual ::grpc::Status ReadDeviceAttributeMeta(::grpc::ClientContext* context, const ::mascot::ReadDeviceAttributeMetaMessage& request, ::mascot::DeviceAttributeMeta* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DeviceAttributeMeta>> AsyncReadDeviceAttributeMeta(::grpc::ClientContext* context, const ::mascot::ReadDeviceAttributeMetaMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DeviceAttributeMeta>>(AsyncReadDeviceAttributeMetaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DeviceAttributeMeta>> PrepareAsyncReadDeviceAttributeMeta(::grpc::ClientContext* context, const ::mascot::ReadDeviceAttributeMetaMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DeviceAttributeMeta>>(PrepareAsyncReadDeviceAttributeMetaRaw(context, request, cq));
    }
    virtual ::grpc::Status WriteDeviceAttributeMeta(::grpc::ClientContext* context, const ::mascot::DeviceAttributeMeta& request, ::mascot::WriteReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>> AsyncWriteDeviceAttributeMeta(::grpc::ClientContext* context, const ::mascot::DeviceAttributeMeta& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>>(AsyncWriteDeviceAttributeMetaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>> PrepareAsyncWriteDeviceAttributeMeta(::grpc::ClientContext* context, const ::mascot::DeviceAttributeMeta& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>>(PrepareAsyncWriteDeviceAttributeMetaRaw(context, request, cq));
    }
    // Subscriptions
    virtual ::grpc::Status Subscribe(::grpc::ClientContext* context, const ::mascot::SubscribeMessage& request, ::mascot::SubscribeReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::SubscribeReply>> AsyncSubscribe(::grpc::ClientContext* context, const ::mascot::SubscribeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::SubscribeReply>>(AsyncSubscribeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::SubscribeReply>> PrepareAsyncSubscribe(::grpc::ClientContext* context, const ::mascot::SubscribeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::SubscribeReply>>(PrepareAsyncSubscribeRaw(context, request, cq));
    }
    virtual ::grpc::Status Unsubscribe(::grpc::ClientContext* context, const ::mascot::UnsubscribeMessage& request, ::mascot::UnsubscribeReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::UnsubscribeReply>> AsyncUnsubscribe(::grpc::ClientContext* context, const ::mascot::UnsubscribeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::UnsubscribeReply>>(AsyncUnsubscribeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::UnsubscribeReply>> PrepareAsyncUnsubscribe(::grpc::ClientContext* context, const ::mascot::UnsubscribeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::UnsubscribeReply>>(PrepareAsyncUnsubscribeRaw(context, request, cq));
    }
    // Commands
    virtual ::grpc::Status ExecuteCommand(::grpc::ClientContext* context, const ::mascot::CommandMessage& request, ::mascot::CommandReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::CommandReply>> AsyncExecuteCommand(::grpc::ClientContext* context, const ::mascot::CommandMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::CommandReply>>(AsyncExecuteCommandRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::CommandReply>> PrepareAsyncExecuteCommand(::grpc::ClientContext* context, const ::mascot::CommandMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::CommandReply>>(PrepareAsyncExecuteCommandRaw(context, request, cq));
    }
  private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::AttributeListReply>* AsyncGetAttributeListRaw(::grpc::ClientContext* context, const ::mascot::GetAttributeListMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::AttributeListReply>* PrepareAsyncGetAttributeListRaw(::grpc::ClientContext* context, const ::mascot::GetAttributeListMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::CommandListReply>* AsyncGetCommandListRaw(::grpc::ClientContext* context, const ::mascot::GetCommandListMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::CommandListReply>* PrepareAsyncGetCommandListRaw(::grpc::ClientContext* context, const ::mascot::GetCommandListMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::ReadAttributeReply>* AsyncReadAttributeRaw(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::ReadAttributeReply>* PrepareAsyncReadAttributeRaw(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>* AsyncWriteAttributeRaw(::grpc::ClientContext* context, const ::mascot::WriteAttributeMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>* PrepareAsyncWriteAttributeRaw(::grpc::ClientContext* context, const ::mascot::WriteAttributeMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::AttributeConfigReply>* AsyncReadAttributeConfigRaw(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::AttributeConfigReply>* PrepareAsyncReadAttributeConfigRaw(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DeviceProperties>* AsyncReadDevicePropertiesRaw(::grpc::ClientContext* context, const ::mascot::ReadDevicePropertiesMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DeviceProperties>* PrepareAsyncReadDevicePropertiesRaw(::grpc::ClientContext* context, const ::mascot::ReadDevicePropertiesMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>* AsyncWriteDevicePropertiesRaw(::grpc::ClientContext* context, const ::mascot::DeviceProperties& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>* PrepareAsyncWriteDevicePropertiesRaw(::grpc::ClientContext* context, const ::mascot::DeviceProperties& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DeviceAttributeMeta>* AsyncReadDeviceAttributeMetaRaw(::grpc::ClientContext* context, const ::mascot::ReadDeviceAttributeMetaMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DeviceAttributeMeta>* PrepareAsyncReadDeviceAttributeMetaRaw(::grpc::ClientContext* context, const ::mascot::ReadDeviceAttributeMetaMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>* AsyncWriteDeviceAttributeMetaRaw(::grpc::ClientContext* context, const ::mascot::DeviceAttributeMeta& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::WriteReply>* PrepareAsyncWriteDeviceAttributeMetaRaw(::grpc::ClientContext* context, const ::mascot::DeviceAttributeMeta& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::SubscribeReply>* AsyncSubscribeRaw(::grpc::ClientContext* context, const ::mascot::SubscribeMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::SubscribeReply>* PrepareAsyncSubscribeRaw(::grpc::ClientContext* context, const ::mascot::SubscribeMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::UnsubscribeReply>* AsyncUnsubscribeRaw(::grpc::ClientContext* context, const ::mascot::UnsubscribeMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::UnsubscribeReply>* PrepareAsyncUnsubscribeRaw(::grpc::ClientContext* context, const ::mascot::UnsubscribeMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::CommandReply>* AsyncExecuteCommandRaw(::grpc::ClientContext* context, const ::mascot::CommandMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::CommandReply>* PrepareAsyncExecuteCommandRaw(::grpc::ClientContext* context, const ::mascot::CommandMessage& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel);
    ::grpc::Status GetAttributeList(::grpc::ClientContext* context, const ::mascot::GetAttributeListMessage& request, ::mascot::AttributeListReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::AttributeListReply>> AsyncGetAttributeList(::grpc::ClientContext* context, const ::mascot::GetAttributeListMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::AttributeListReply>>(AsyncGetAttributeListRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::AttributeListReply>> PrepareAsyncGetAttributeList(::grpc::ClientContext* context, const ::mascot::GetAttributeListMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::AttributeListReply>>(PrepareAsyncGetAttributeListRaw(context, request, cq));
    }
    ::grpc::Status GetCommandList(::grpc::ClientContext* context, const ::mascot::GetCommandListMessage& request, ::mascot::CommandListReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::CommandListReply>> AsyncGetCommandList(::grpc::ClientContext* context, const ::mascot::GetCommandListMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::CommandListReply>>(AsyncGetCommandListRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::CommandListReply>> PrepareAsyncGetCommandList(::grpc::ClientContext* context, const ::mascot::GetCommandListMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::CommandListReply>>(PrepareAsyncGetCommandListRaw(context, request, cq));
    }
    ::grpc::Status ReadAttribute(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::mascot::ReadAttributeReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::ReadAttributeReply>> AsyncReadAttribute(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::ReadAttributeReply>>(AsyncReadAttributeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::ReadAttributeReply>> PrepareAsyncReadAttribute(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::ReadAttributeReply>>(PrepareAsyncReadAttributeRaw(context, request, cq));
    }
    ::grpc::Status WriteAttribute(::grpc::ClientContext* context, const ::mascot::WriteAttributeMessage& request, ::mascot::WriteReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>> AsyncWriteAttribute(::grpc::ClientContext* context, const ::mascot::WriteAttributeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>>(AsyncWriteAttributeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>> PrepareAsyncWriteAttribute(::grpc::ClientContext* context, const ::mascot::WriteAttributeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>>(PrepareAsyncWriteAttributeRaw(context, request, cq));
    }
    ::grpc::Status ReadAttributeConfig(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::mascot::AttributeConfigReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::AttributeConfigReply>> AsyncReadAttributeConfig(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::AttributeConfigReply>>(AsyncReadAttributeConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::AttributeConfigReply>> PrepareAsyncReadAttributeConfig(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::AttributeConfigReply>>(PrepareAsyncReadAttributeConfigRaw(context, request, cq));
    }
    ::grpc::Status ReadDeviceProperties(::grpc::ClientContext* context, const ::mascot::ReadDevicePropertiesMessage& request, ::mascot::DeviceProperties* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DeviceProperties>> AsyncReadDeviceProperties(::grpc::ClientContext* context, const ::mascot::ReadDevicePropertiesMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DeviceProperties>>(AsyncReadDevicePropertiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DeviceProperties>> PrepareAsyncReadDeviceProperties(::grpc::ClientContext* context, const ::mascot::ReadDevicePropertiesMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DeviceProperties>>(PrepareAsyncReadDevicePropertiesRaw(context, request, cq));
    }
    ::grpc::Status WriteDeviceProperties(::grpc::ClientContext* context, const ::mascot::DeviceProperties& request, ::mascot::WriteReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>> AsyncWriteDeviceProperties(::grpc::ClientContext* context, const ::mascot::DeviceProperties& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>>(AsyncWriteDevicePropertiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>> PrepareAsyncWriteDeviceProperties(::grpc::ClientContext* context, const ::mascot::DeviceProperties& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>>(PrepareAsyncWriteDevicePropertiesRaw(context, request, cq));
    }
    ::grpc::Status ReadDeviceAttributeMeta(::grpc::ClientContext* context, const ::mascot::ReadDeviceAttributeMetaMessage& request, ::mascot::DeviceAttributeMeta* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DeviceAttributeMeta>> AsyncReadDeviceAttributeMeta(::grpc::ClientContext* context, const ::mascot::ReadDeviceAttributeMetaMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DeviceAttributeMeta>>(AsyncReadDeviceAttributeMetaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DeviceAttributeMeta>> PrepareAsyncReadDeviceAttributeMeta(::grpc::ClientContext* context, const ::mascot::ReadDeviceAttributeMetaMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DeviceAttributeMeta>>(PrepareAsyncReadDeviceAttributeMetaRaw(context, request, cq));
    }
    ::grpc::Status WriteDeviceAttributeMeta(::grpc::ClientContext* context, const ::mascot::DeviceAttributeMeta& request, ::mascot::WriteReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>> AsyncWriteDeviceAttributeMeta(::grpc::ClientContext* context, const ::mascot::DeviceAttributeMeta& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>>(AsyncWriteDeviceAttributeMetaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>> PrepareAsyncWriteDeviceAttributeMeta(::grpc::ClientContext* context, const ::mascot::DeviceAttributeMeta& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>>(PrepareAsyncWriteDeviceAttributeMetaRaw(context, request, cq));
    }
    ::grpc::Status Subscribe(::grpc::ClientContext* context, const ::mascot::SubscribeMessage& request, ::mascot::SubscribeReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::SubscribeReply>> AsyncSubscribe(::grpc::ClientContext* context, const ::mascot::SubscribeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::SubscribeReply>>(AsyncSubscribeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::SubscribeReply>> PrepareAsyncSubscribe(::grpc::ClientContext* context, const ::mascot::SubscribeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::SubscribeReply>>(PrepareAsyncSubscribeRaw(context, request, cq));
    }
    ::grpc::Status Unsubscribe(::grpc::ClientContext* context, const ::mascot::UnsubscribeMessage& request, ::mascot::UnsubscribeReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::UnsubscribeReply>> AsyncUnsubscribe(::grpc::ClientContext* context, const ::mascot::UnsubscribeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::UnsubscribeReply>>(AsyncUnsubscribeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::UnsubscribeReply>> PrepareAsyncUnsubscribe(::grpc::ClientContext* context, const ::mascot::UnsubscribeMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::UnsubscribeReply>>(PrepareAsyncUnsubscribeRaw(context, request, cq));
    }
    ::grpc::Status ExecuteCommand(::grpc::ClientContext* context, const ::mascot::CommandMessage& request, ::mascot::CommandReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::CommandReply>> AsyncExecuteCommand(::grpc::ClientContext* context, const ::mascot::CommandMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::CommandReply>>(AsyncExecuteCommandRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::CommandReply>> PrepareAsyncExecuteCommand(::grpc::ClientContext* context, const ::mascot::CommandMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::CommandReply>>(PrepareAsyncExecuteCommandRaw(context, request, cq));
    }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    ::grpc::ClientAsyncResponseReader< ::mascot::AttributeListReply>* AsyncGetAttributeListRaw(::grpc::ClientContext* context, const ::mascot::GetAttributeListMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::AttributeListReply>* PrepareAsyncGetAttributeListRaw(::grpc::ClientContext* context, const ::mascot::GetAttributeListMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::CommandListReply>* AsyncGetCommandListRaw(::grpc::ClientContext* context, const ::mascot::GetCommandListMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::CommandListReply>* PrepareAsyncGetCommandListRaw(::grpc::ClientContext* context, const ::mascot::GetCommandListMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::ReadAttributeReply>* AsyncReadAttributeRaw(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::ReadAttributeReply>* PrepareAsyncReadAttributeRaw(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>* AsyncWriteAttributeRaw(::grpc::ClientContext* context, const ::mascot::WriteAttributeMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>* PrepareAsyncWriteAttributeRaw(::grpc::ClientContext* context, const ::mascot::WriteAttributeMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::AttributeConfigReply>* AsyncReadAttributeConfigRaw(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::AttributeConfigReply>* PrepareAsyncReadAttributeConfigRaw(::grpc::ClientContext* context, const ::mascot::ReadAttributeMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DeviceProperties>* AsyncReadDevicePropertiesRaw(::grpc::ClientContext* context, const ::mascot::ReadDevicePropertiesMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DeviceProperties>* PrepareAsyncReadDevicePropertiesRaw(::grpc::ClientContext* context, const ::mascot::ReadDevicePropertiesMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>* AsyncWriteDevicePropertiesRaw(::grpc::ClientContext* context, const ::mascot::DeviceProperties& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>* PrepareAsyncWriteDevicePropertiesRaw(::grpc::ClientContext* context, const ::mascot::DeviceProperties& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DeviceAttributeMeta>* AsyncReadDeviceAttributeMetaRaw(::grpc::ClientContext* context, const ::mascot::ReadDeviceAttributeMetaMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DeviceAttributeMeta>* PrepareAsyncReadDeviceAttributeMetaRaw(::grpc::ClientContext* context, const ::mascot::ReadDeviceAttributeMetaMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>* AsyncWriteDeviceAttributeMetaRaw(::grpc::ClientContext* context, const ::mascot::DeviceAttributeMeta& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::WriteReply>* PrepareAsyncWriteDeviceAttributeMetaRaw(::grpc::ClientContext* context, const ::mascot::DeviceAttributeMeta& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::SubscribeReply>* AsyncSubscribeRaw(::grpc::ClientContext* context, const ::mascot::SubscribeMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::SubscribeReply>* PrepareAsyncSubscribeRaw(::grpc::ClientContext* context, const ::mascot::SubscribeMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::UnsubscribeReply>* AsyncUnsubscribeRaw(::grpc::ClientContext* context, const ::mascot::UnsubscribeMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::UnsubscribeReply>* PrepareAsyncUnsubscribeRaw(::grpc::ClientContext* context, const ::mascot::UnsubscribeMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::CommandReply>* AsyncExecuteCommandRaw(::grpc::ClientContext* context, const ::mascot::CommandMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::CommandReply>* PrepareAsyncExecuteCommandRaw(::grpc::ClientContext* context, const ::mascot::CommandMessage& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetAttributeList_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCommandList_;
    const ::grpc::internal::RpcMethod rpcmethod_ReadAttribute_;
    const ::grpc::internal::RpcMethod rpcmethod_WriteAttribute_;
    const ::grpc::internal::RpcMethod rpcmethod_ReadAttributeConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_ReadDeviceProperties_;
    const ::grpc::internal::RpcMethod rpcmethod_WriteDeviceProperties_;
    const ::grpc::internal::RpcMethod rpcmethod_ReadDeviceAttributeMeta_;
    const ::grpc::internal::RpcMethod rpcmethod_WriteDeviceAttributeMeta_;
    const ::grpc::internal::RpcMethod rpcmethod_Subscribe_;
    const ::grpc::internal::RpcMethod rpcmethod_Unsubscribe_;
    const ::grpc::internal::RpcMethod rpcmethod_ExecuteCommand_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Device definition
    virtual ::grpc::Status GetAttributeList(::grpc::ServerContext* context, const ::mascot::GetAttributeListMessage* request, ::mascot::AttributeListReply* response);
    virtual ::grpc::Status GetCommandList(::grpc::ServerContext* context, const ::mascot::GetCommandListMessage* request, ::mascot::CommandListReply* response);
    // Attributes
    virtual ::grpc::Status ReadAttribute(::grpc::ServerContext* context, const ::mascot::ReadAttributeMessage* request, ::mascot::ReadAttributeReply* response);
    virtual ::grpc::Status WriteAttribute(::grpc::ServerContext* context, const ::mascot::WriteAttributeMessage* request, ::mascot::WriteReply* response);
    // Configuration
    virtual ::grpc::Status ReadAttributeConfig(::grpc::ServerContext* context, const ::mascot::ReadAttributeMessage* request, ::mascot::AttributeConfigReply* response);
    // Properties
    virtual ::grpc::Status ReadDeviceProperties(::grpc::ServerContext* context, const ::mascot::ReadDevicePropertiesMessage* request, ::mascot::DeviceProperties* response);
    virtual ::grpc::Status WriteDeviceProperties(::grpc::ServerContext* context, const ::mascot::DeviceProperties* request, ::mascot::WriteReply* response);
    // Attribute Meta
    virtual ::grpc::Status ReadDeviceAttributeMeta(::grpc::ServerContext* context, const ::mascot::ReadDeviceAttributeMetaMessage* request, ::mascot::DeviceAttributeMeta* response);
    virtual ::grpc::Status WriteDeviceAttributeMeta(::grpc::ServerContext* context, const ::mascot::DeviceAttributeMeta* request, ::mascot::WriteReply* response);
    // Subscriptions
    virtual ::grpc::Status Subscribe(::grpc::ServerContext* context, const ::mascot::SubscribeMessage* request, ::mascot::SubscribeReply* response);
    virtual ::grpc::Status Unsubscribe(::grpc::ServerContext* context, const ::mascot::UnsubscribeMessage* request, ::mascot::UnsubscribeReply* response);
    // Commands
    virtual ::grpc::Status ExecuteCommand(::grpc::ServerContext* context, const ::mascot::CommandMessage* request, ::mascot::CommandReply* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAttributeList : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_GetAttributeList() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetAttributeList() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttributeList(::grpc::ServerContext* context, const ::mascot::GetAttributeListMessage* request, ::mascot::AttributeListReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAttributeList(::grpc::ServerContext* context, ::mascot::GetAttributeListMessage* request, ::grpc::ServerAsyncResponseWriter< ::mascot::AttributeListReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCommandList : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_GetCommandList() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetCommandList() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCommandList(::grpc::ServerContext* context, const ::mascot::GetCommandListMessage* request, ::mascot::CommandListReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCommandList(::grpc::ServerContext* context, ::mascot::GetCommandListMessage* request, ::grpc::ServerAsyncResponseWriter< ::mascot::CommandListReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReadAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_ReadAttribute() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ReadAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadAttribute(::grpc::ServerContext* context, const ::mascot::ReadAttributeMessage* request, ::mascot::ReadAttributeReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReadAttribute(::grpc::ServerContext* context, ::mascot::ReadAttributeMessage* request, ::grpc::ServerAsyncResponseWriter< ::mascot::ReadAttributeReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_WriteAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_WriteAttribute() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_WriteAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status WriteAttribute(::grpc::ServerContext* context, const ::mascot::WriteAttributeMessage* request, ::mascot::WriteReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestWriteAttribute(::grpc::ServerContext* context, ::mascot::WriteAttributeMessage* request, ::grpc::ServerAsyncResponseWriter< ::mascot::WriteReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReadAttributeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_ReadAttributeConfig() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ReadAttributeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadAttributeConfig(::grpc::ServerContext* context, const ::mascot::ReadAttributeMessage* request, ::mascot::AttributeConfigReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReadAttributeConfig(::grpc::ServerContext* context, ::mascot::ReadAttributeMessage* request, ::grpc::ServerAsyncResponseWriter< ::mascot::AttributeConfigReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReadDeviceProperties : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_ReadDeviceProperties() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ReadDeviceProperties() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadDeviceProperties(::grpc::ServerContext* context, const ::mascot::ReadDevicePropertiesMessage* request, ::mascot::DeviceProperties* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReadDeviceProperties(::grpc::ServerContext* context, ::mascot::ReadDevicePropertiesMessage* request, ::grpc::ServerAsyncResponseWriter< ::mascot::DeviceProperties>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_WriteDeviceProperties : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_WriteDeviceProperties() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_WriteDeviceProperties() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status WriteDeviceProperties(::grpc::ServerContext* context, const ::mascot::DeviceProperties* request, ::mascot::WriteReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestWriteDeviceProperties(::grpc::ServerContext* context, ::mascot::DeviceProperties* request, ::grpc::ServerAsyncResponseWriter< ::mascot::WriteReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReadDeviceAttributeMeta : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_ReadDeviceAttributeMeta() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ReadDeviceAttributeMeta() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadDeviceAttributeMeta(::grpc::ServerContext* context, const ::mascot::ReadDeviceAttributeMetaMessage* request, ::mascot::DeviceAttributeMeta* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReadDeviceAttributeMeta(::grpc::ServerContext* context, ::mascot::ReadDeviceAttributeMetaMessage* request, ::grpc::ServerAsyncResponseWriter< ::mascot::DeviceAttributeMeta>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_WriteDeviceAttributeMeta : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_WriteDeviceAttributeMeta() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_WriteDeviceAttributeMeta() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status WriteDeviceAttributeMeta(::grpc::ServerContext* context, const ::mascot::DeviceAttributeMeta* request, ::mascot::WriteReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestWriteDeviceAttributeMeta(::grpc::ServerContext* context, ::mascot::DeviceAttributeMeta* request, ::grpc::ServerAsyncResponseWriter< ::mascot::WriteReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Subscribe : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_Subscribe() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_Subscribe() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Subscribe(::grpc::ServerContext* context, const ::mascot::SubscribeMessage* request, ::mascot::SubscribeReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSubscribe(::grpc::ServerContext* context, ::mascot::SubscribeMessage* request, ::grpc::ServerAsyncResponseWriter< ::mascot::SubscribeReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Unsubscribe : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_Unsubscribe() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_Unsubscribe() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Unsubscribe(::grpc::ServerContext* context, const ::mascot::UnsubscribeMessage* request, ::mascot::UnsubscribeReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUnsubscribe(::grpc::ServerContext* context, ::mascot::UnsubscribeMessage* request, ::grpc::ServerAsyncResponseWriter< ::mascot::UnsubscribeReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ExecuteCommand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_ExecuteCommand() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ExecuteCommand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExecuteCommand(::grpc::ServerContext* context, const ::mascot::CommandMessage* request, ::mascot::CommandReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExecuteCommand(::grpc::ServerContext* context, ::mascot::CommandMessage* request, ::grpc::ServerAsyncResponseWriter< ::mascot::CommandReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetAttributeList<WithAsyncMethod_GetCommandList<WithAsyncMethod_ReadAttribute<WithAsyncMethod_WriteAttribute<WithAsyncMethod_ReadAttributeConfig<WithAsyncMethod_ReadDeviceProperties<WithAsyncMethod_WriteDeviceProperties<WithAsyncMethod_ReadDeviceAttributeMeta<WithAsyncMethod_WriteDeviceAttributeMeta<WithAsyncMethod_Subscribe<WithAsyncMethod_Unsubscribe<WithAsyncMethod_ExecuteCommand<Service > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithGenericMethod_GetAttributeList : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_GetAttributeList() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetAttributeList() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttributeList(::grpc::ServerContext* context, const ::mascot::GetAttributeListMessage* request, ::mascot::AttributeListReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCommandList : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_GetCommandList() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetCommandList() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCommandList(::grpc::ServerContext* context, const ::mascot::GetCommandListMessage* request, ::mascot::CommandListReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReadAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_ReadAttribute() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ReadAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadAttribute(::grpc::ServerContext* context, const ::mascot::ReadAttributeMessage* request, ::mascot::ReadAttributeReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_WriteAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_WriteAttribute() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_WriteAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status WriteAttribute(::grpc::ServerContext* context, const ::mascot::WriteAttributeMessage* request, ::mascot::WriteReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReadAttributeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_ReadAttributeConfig() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ReadAttributeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadAttributeConfig(::grpc::ServerContext* context, const ::mascot::ReadAttributeMessage* request, ::mascot::AttributeConfigReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReadDeviceProperties : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_ReadDeviceProperties() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ReadDeviceProperties() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadDeviceProperties(::grpc::ServerContext* context, const ::mascot::ReadDevicePropertiesMessage* request, ::mascot::DeviceProperties* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_WriteDeviceProperties : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_WriteDeviceProperties() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_WriteDeviceProperties() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status WriteDeviceProperties(::grpc::ServerContext* context, const ::mascot::DeviceProperties* request, ::mascot::WriteReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReadDeviceAttributeMeta : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_ReadDeviceAttributeMeta() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ReadDeviceAttributeMeta() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadDeviceAttributeMeta(::grpc::ServerContext* context, const ::mascot::ReadDeviceAttributeMetaMessage* request, ::mascot::DeviceAttributeMeta* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_WriteDeviceAttributeMeta : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_WriteDeviceAttributeMeta() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_WriteDeviceAttributeMeta() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status WriteDeviceAttributeMeta(::grpc::ServerContext* context, const ::mascot::DeviceAttributeMeta* request, ::mascot::WriteReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Subscribe : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_Subscribe() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_Subscribe() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Subscribe(::grpc::ServerContext* context, const ::mascot::SubscribeMessage* request, ::mascot::SubscribeReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Unsubscribe : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_Unsubscribe() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_Unsubscribe() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Unsubscribe(::grpc::ServerContext* context, const ::mascot::UnsubscribeMessage* request, ::mascot::UnsubscribeReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ExecuteCommand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_ExecuteCommand() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ExecuteCommand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExecuteCommand(::grpc::ServerContext* context, const ::mascot::CommandMessage* request, ::mascot::CommandReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAttributeList : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_GetAttributeList() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::GetAttributeListMessage, ::mascot::AttributeListReply>(std::bind(&WithStreamedUnaryMethod_GetAttributeList<BaseClass>::StreamedGetAttributeList, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_GetAttributeList() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAttributeList(::grpc::ServerContext* context, const ::mascot::GetAttributeListMessage* request, ::mascot::AttributeListReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAttributeList(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::GetAttributeListMessage,::mascot::AttributeListReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCommandList : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_GetCommandList() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::GetCommandListMessage, ::mascot::CommandListReply>(std::bind(&WithStreamedUnaryMethod_GetCommandList<BaseClass>::StreamedGetCommandList, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_GetCommandList() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCommandList(::grpc::ServerContext* context, const ::mascot::GetCommandListMessage* request, ::mascot::CommandListReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCommandList(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::GetCommandListMessage,::mascot::CommandListReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReadAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_ReadAttribute() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::ReadAttributeMessage, ::mascot::ReadAttributeReply>(std::bind(&WithStreamedUnaryMethod_ReadAttribute<BaseClass>::StreamedReadAttribute, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ReadAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReadAttribute(::grpc::ServerContext* context, const ::mascot::ReadAttributeMessage* request, ::mascot::ReadAttributeReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReadAttribute(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::ReadAttributeMessage,::mascot::ReadAttributeReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_WriteAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_WriteAttribute() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::WriteAttributeMessage, ::mascot::WriteReply>(std::bind(&WithStreamedUnaryMethod_WriteAttribute<BaseClass>::StreamedWriteAttribute, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_WriteAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status WriteAttribute(::grpc::ServerContext* context, const ::mascot::WriteAttributeMessage* request, ::mascot::WriteReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedWriteAttribute(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::WriteAttributeMessage,::mascot::WriteReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReadAttributeConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_ReadAttributeConfig() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::ReadAttributeMessage, ::mascot::AttributeConfigReply>(std::bind(&WithStreamedUnaryMethod_ReadAttributeConfig<BaseClass>::StreamedReadAttributeConfig, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ReadAttributeConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReadAttributeConfig(::grpc::ServerContext* context, const ::mascot::ReadAttributeMessage* request, ::mascot::AttributeConfigReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReadAttributeConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::ReadAttributeMessage,::mascot::AttributeConfigReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReadDeviceProperties : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_ReadDeviceProperties() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::ReadDevicePropertiesMessage, ::mascot::DeviceProperties>(std::bind(&WithStreamedUnaryMethod_ReadDeviceProperties<BaseClass>::StreamedReadDeviceProperties, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ReadDeviceProperties() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReadDeviceProperties(::grpc::ServerContext* context, const ::mascot::ReadDevicePropertiesMessage* request, ::mascot::DeviceProperties* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReadDeviceProperties(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::ReadDevicePropertiesMessage,::mascot::DeviceProperties>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_WriteDeviceProperties : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_WriteDeviceProperties() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::DeviceProperties, ::mascot::WriteReply>(std::bind(&WithStreamedUnaryMethod_WriteDeviceProperties<BaseClass>::StreamedWriteDeviceProperties, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_WriteDeviceProperties() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status WriteDeviceProperties(::grpc::ServerContext* context, const ::mascot::DeviceProperties* request, ::mascot::WriteReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedWriteDeviceProperties(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::DeviceProperties,::mascot::WriteReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReadDeviceAttributeMeta : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_ReadDeviceAttributeMeta() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::ReadDeviceAttributeMetaMessage, ::mascot::DeviceAttributeMeta>(std::bind(&WithStreamedUnaryMethod_ReadDeviceAttributeMeta<BaseClass>::StreamedReadDeviceAttributeMeta, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ReadDeviceAttributeMeta() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReadDeviceAttributeMeta(::grpc::ServerContext* context, const ::mascot::ReadDeviceAttributeMetaMessage* request, ::mascot::DeviceAttributeMeta* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReadDeviceAttributeMeta(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::ReadDeviceAttributeMetaMessage,::mascot::DeviceAttributeMeta>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_WriteDeviceAttributeMeta : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_WriteDeviceAttributeMeta() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::DeviceAttributeMeta, ::mascot::WriteReply>(std::bind(&WithStreamedUnaryMethod_WriteDeviceAttributeMeta<BaseClass>::StreamedWriteDeviceAttributeMeta, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_WriteDeviceAttributeMeta() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status WriteDeviceAttributeMeta(::grpc::ServerContext* context, const ::mascot::DeviceAttributeMeta* request, ::mascot::WriteReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedWriteDeviceAttributeMeta(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::DeviceAttributeMeta,::mascot::WriteReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Subscribe : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_Subscribe() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::SubscribeMessage, ::mascot::SubscribeReply>(std::bind(&WithStreamedUnaryMethod_Subscribe<BaseClass>::StreamedSubscribe, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_Subscribe() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Subscribe(::grpc::ServerContext* context, const ::mascot::SubscribeMessage* request, ::mascot::SubscribeReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSubscribe(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::SubscribeMessage,::mascot::SubscribeReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Unsubscribe : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_Unsubscribe() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::UnsubscribeMessage, ::mascot::UnsubscribeReply>(std::bind(&WithStreamedUnaryMethod_Unsubscribe<BaseClass>::StreamedUnsubscribe, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_Unsubscribe() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Unsubscribe(::grpc::ServerContext* context, const ::mascot::UnsubscribeMessage* request, ::mascot::UnsubscribeReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUnsubscribe(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::UnsubscribeMessage,::mascot::UnsubscribeReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExecuteCommand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_ExecuteCommand() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::CommandMessage, ::mascot::CommandReply>(std::bind(&WithStreamedUnaryMethod_ExecuteCommand<BaseClass>::StreamedExecuteCommand, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ExecuteCommand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExecuteCommand(::grpc::ServerContext* context, const ::mascot::CommandMessage* request, ::mascot::CommandReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExecuteCommand(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::CommandMessage,::mascot::CommandReply>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetAttributeList<WithStreamedUnaryMethod_GetCommandList<WithStreamedUnaryMethod_ReadAttribute<WithStreamedUnaryMethod_WriteAttribute<WithStreamedUnaryMethod_ReadAttributeConfig<WithStreamedUnaryMethod_ReadDeviceProperties<WithStreamedUnaryMethod_WriteDeviceProperties<WithStreamedUnaryMethod_ReadDeviceAttributeMeta<WithStreamedUnaryMethod_WriteDeviceAttributeMeta<WithStreamedUnaryMethod_Subscribe<WithStreamedUnaryMethod_Unsubscribe<WithStreamedUnaryMethod_ExecuteCommand<Service > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetAttributeList<WithStreamedUnaryMethod_GetCommandList<WithStreamedUnaryMethod_ReadAttribute<WithStreamedUnaryMethod_WriteAttribute<WithStreamedUnaryMethod_ReadAttributeConfig<WithStreamedUnaryMethod_ReadDeviceProperties<WithStreamedUnaryMethod_WriteDeviceProperties<WithStreamedUnaryMethod_ReadDeviceAttributeMeta<WithStreamedUnaryMethod_WriteDeviceAttributeMeta<WithStreamedUnaryMethod_Subscribe<WithStreamedUnaryMethod_Unsubscribe<WithStreamedUnaryMethod_ExecuteCommand<Service > > > > > > > > > > > > StreamedService;
};

}  // namespace mascot


#endif  // GRPC_device_5fserver_2eproto__INCLUDED
